<?php
/* Tracker Configuration
 *
 *  This file provides configuration informatino for
 *  the tracker. The user-editable variables are at the top. It is
 *  recommended that you do not change the database settings
 *  unless you know what you are doing.
 */

//Maximum reannounce interval.
$GLOBALS["report_interval"] = 1800;

//Minimum reannounce interval. Optional.
$GLOBALS["min_interval"] = 300;

//Number of peers to send in one request.
$GLOBALS["maxpeers"] = 50;

//If set to true, then the tracker will accept any and all
//torrents given to it. Not recommended, but available if you need it.
$GLOBALS["dynamic_torrents"] = false;

//// If set to true, NAT checking will be performed.
// This may cause trouble with some providers, so it's
// off by default.
$GLOBALS["NAT"] = false;

// Persistent connections: true or false.
// Check with your webmaster to see if you're allowed to use these.
// Highly recommended, especially for higher loads.
$GLOBALS["persist"] = false;

// Allow users to override ip= ?
// Enable this if you know people have a legit reason to use
// this function. Leave disabled otherwise.
$GLOBALS["ip_override"] = false;

// Denie Shareaza Clients?
// True is default.
$GLOBALS["DenieShareaza"] = true;

//// If set to 1, Stats will show in a seperated table below the torrent listings.
// If set to 2, Stats will show on the same table as the torrent listings.
// If set to 0, no stats will show.
// Defualt is "seperated"
$GLOBALS["stats"] = 1;

//// Theme To Use (Theme Templates can be found in the ThemeTemplate directory) - Default is nyt.
// Make sure you include the folder of the theme you pick. IE. Upload the NYT folder for default theme.
$theme = "nyt";

//// URL of the tracker IE. http://www.yourserver.com/bittorrent/
$GLOBALS["trackerurl"] = "";

// Enter the directory the scripts are in. Leave it "" to let it get
// it automaticly.
$GLOBALS["dir"] = "";

//// Enable GZip Compression: True or False. Defualt = false!
//Run gziptest.php to see if your server supports gzip.
$GLOBALS["gzip"] = false;

//// (If Enabled) What Level? (1-9; 1 with low compression, 9 with High Compression)
$GLOBALS["gzip"] = 5;


/////////// End of User Configuration ///////////



$dbhost = "";  $dbuser = "";  $dbpass = "";  $database = "";

?>