<?php


//////////////////////////////////////////////////////////////////
// Worker functions


// Uses the mysql database connection to perform string math. :)
// Used by byte counting functions
// No error handling as we assume nothing can go wrong. :|
function sqlAdd($left, $right)
{
	$query = 'SELECT '.$left.'+'.$right;
	$results = mysql_query($query) or showError("Database error.");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}

// Ditto
function sqlSubtract($left, $right)
{
	$query = 'SELECT '.$left.'-'.$right;
	$results = mysql_query($query) or showError("Database error");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}

function sqlDivide($left, $right)
{
	$query = 'SELECT '.$left.'/'.$right;
	$results = mysql_query($query) or showError("Database error");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}

function sqlMultiply($left, $right)
{
	$query = 'SELECT '.$left.'*'.$right;
	$results = mysql_query($query) or showError("Database error");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}


// Runs a query with no regard for the result
function quickQuery($query)
{
	$results = @mysql_query($query);
	if (!is_bool($results))
		mysql_free_result($results);
	else
		return $results;
	return true;
}

// Reports an error to the client in $message.
// Any other output will confuse the client, so please don't do that.
function showError($message, $log=false)
{
  if ($log)
	  error_log("PHPBTTracker: Sent error ($message)");
  echo "d14:failure reason".strlen($message).":$message"."e";
  exit(0);
}


// From the PHP web site user comments, and fixed to prevent PHP warnings.
function hex2bin($hexdata) {
  $bindata = ""; 
  for ($i=0;$i<strlen($hexdata);$i+=2) {
    $bindata.=chr(hexdec(substr($hexdata,$i,2)));
  }
 
  return $bindata;
}



// Used by newtorrents.php and the dynamic_torrents setting
// Returns true/false, depending on if there were errors.
function makeTorrent($hash, $tolerate = false)
{
	if (strlen($hash) != 40)
		showError("makeTorrent: Received an invalid hash");
	$result = true;
	$query = "CREATE TABLE x$hash (peer_id char(40), bytes bigint NOT NULL default 0, ip varchar(50) NOT NULL default \"error.x\", port varchar(5) NOT NULL default \"0\", status enum('leecher','seeder') NOT NULL, lastupdate bigint NOT NULL default 0, sequence bigint AUTO_INCREMENT NOT NULL, peerstart bigint NOT NULL default 0, upbytes bigint NOT NULL default 0, natuser enum('N', 'Y') not null default 'N', primary key(sequence), unique(peer_id))";
	if (!@mysql_query($query))
		$result = false;
	if (!$result && !$tolerate)
		return false;
	$query = "INSERT INTO summary set info_hash=\"".$hash."\", lastSpeedCycle=".time().", created=".time();
	if (!@mysql_query($query))
		$result = false;
	return $result;
}

// Returns true if the torrent exists.
// Currently checks by locating the row in "summary"
// Always returns true if $dynamic_torrents=="1" unless an error occured
function verifyTorrent($hash)
{
	$query = "SELECT info_hash FROM summary where info_hash=\"$hash\"";
	$results = mysql_query($query);
	
	$row = mysql_fetch_row($results);
	
	if ($row)
		return true;
	
	if ($GLOBALS["dynamic_torrents"])
		return makeTorrent($hash);

	return false;
}


// Verifies a hash is valid
function verifyHash($hash)
{
	if (strlen($hash) != 40)
		return false;
	$hash = strtolower($hash);
	for ($i = 0; $i < strlen($hash); $i++)
	{
		if ($hash[$i] >= '0' && $hash[$i] <= '9')
			continue;
		if ($hash[$i] >= 'a' && $hash[$i] <= 'f')
			continue;
		break;
	}
	if ($i != 40)
		return false;
	return true;
}

// Returns info on one peer
function getPeerInfo($user, $hash)
{
	// If "trackerid" is set, let's try that
	
	if (isset($GLOBALS["trackerid"]))
	{
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence,upbytes FROM x$hash WHERE sequence=${GLOBALS["trackerid"]}";
		$results = mysql_query($query) or showError("Tracker error: invalid torrent");
		$data = mysql_fetch_row($results);
		if (!$data)
			return false;
		if ($data[0] != $user)
		{
			// Damn, but don't crash just yet.
			$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence,upbytes from x$hash where peer_id=\"$user\"";
			$results = mysql_query($query) or showError("Tracker error: invalid torrent"); 
			$data = mysql_fetch_row($results);
		}
	}
	else
	{
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence,upbytes from x$hash where peer_id=\"$user\"";
		$results = mysql_query($query) or showError("Tracker error: invalid torrent");
		$data = mysql_fetch_row($results);

	}
	
	if (!($data))
		return false;
	
	$return["peer_id"] = $data[0];
	$return["bytes"] = $data[1];
	$return["ip"] = $data[2];
	$return["port"]=$data[3];
	$return["status"] = $data[4];
	$return["lastupdate"] = $data[5];
	$return["trackerid"] = $data[6];
	$return["upbytes"] = $data[7];
	return $return;
}

// Loads all peers into one large bulk, returns false on error
// This has been depreciated and may be deleted soon.
function loadPeers($hash, $rules = "")
{
	$peerno = 0;
	$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,upbytes from x$hash";
	$results = mysql_query($query);
	if (!$results)
		return false;
	while ($data = mysql_fetch_row($results))
	{
		$return[$peerno]["peer_id"] = $data[0];
		$return[$peerno]["bytes"] = $data[1];
		$return[$peerno]["ip"] = $data[2];
		$return[$peerno]["port"]=$data[3];
		$return[$peerno]["status"] = $data[4];
		$return[$peerno]["lastupdate"] = $data[5];
		$return[$peerno]["upbytes"] = $data[6];
		$peerno++;	
	}
	$return["size"] = $peerno;
	mysql_free_result($results);
	return $return;
}

// Slight redesign of loadPeers
function getRandomPeers($hash, $where="")
{
	$peerno = 0;
	// Don't want to send a bad "num peers" for new seeds

	if ($GLOBALS["NAT"])
		$results = mysql_query("SELECT COUNT(*) FROM x$hash WHERE natuser = 'N'");
	else
		$results = mysql_query("SELECT COUNT(*) FROM x$hash");

	$data = mysql_fetch_row($results) or showError("Internal tracker error on getRandomPeers");
	$peercount = (int) $data[0];

	//	Excessive, and not really necessary
//	$results = mysql_query("SELECT COUNT(*) FROM x$hash WHERE natuser = 'N' AND status='seeder'");
//	$data = mysql_fetch_row($results);
//	$seedcount = (int) $data[0];

	$max = $GLOBALS["maxpeers"];

	if ($peercount < $max)
		$random = 0;
	else
		$random = @mt_rand(0, $peercount - $max);

	// ORDER BY RAND() is expensive. Don't do it when the load gets too high
	if ($peercount < 300)
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,upbytes FROM x$hash ".$where." ORDER BY RAND() LIMIT $max";
	else
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,upbytes FROM x$hash LIMIT $random, $max";


	$results = mysql_query($query);
	if (!$results)
		return false;
	while ($data = mysql_fetch_row($results))
	{
		$return[$peerno]["peer_id"] = $data[0];
		$return[$peerno]["bytes"] = $data[1];
		$return[$peerno]["ip"] = $data[2];
		$return[$peerno]["port"]=$data[3];
		$return[$peerno]["status"] = $data[4];
		$return[$peerno]["lastupdate"] = $data[5];
		$return[$peerno]["upbytes"] = $data[6];
		$peerno++;	
	}
	$return["size"] = $peerno;
	$resultcount = mysql_num_rows($results);
	
	$query = mysql_query("SELECT MAX(sequence) FROM x$hash") or showError("Database error");
	$maxsequence = mysql_fetch_row($query); // assume it works
	$return["last"] = $maxsequence[0];
	$return["num peers"] = $peercount;
//	$return["num seeds"] = $seedcount;
	mysql_free_result($results);
	return $return;
}

// Deletes a peer from the system and performs all cleaning up
function killPeer($userid, $hash, $left, $upload)
{
	if (isset($GLOBALS["trackerid"]))
		unset($GLOBALS["trackerid"]);
	$peer = getPeerInfo($userid, $hash);
	$bytes = sqlSubtract($peer["bytes"], $left);
	//$upbytes = sqlSubtract($upload, $peer["upbytes"]);

	quickQuery("DELETE FROM x$hash WHERE peer_id=\"$userid\"");
	if (mysql_affected_rows() == 1)
	{
		if (strcmp($peer["status"], "leecher") == 0)
			quickQuery("UPDATE summary SET leechers=leechers-1 WHERE info_hash=\"$hash\"");
		else if (strcmp($peer["status"], "seeder") == 0)
			quickQuery("UPDATE summary SET seeds=seeds-1 WHERE info_hash=\"$hash\"");
		if (((float)$bytes) > 0)
			quickQuery("UPDATE summary SET dlbytes=dlbytes + $bytes WHERE info_hash=\"$hash\"");
		if ($peer["bytes"] != 0 && $left == 0)
			quickQuery("UPDATE summary SET finished=finished+1 WHERE info_hash=\"$hash\"");
		//if (((float)$upbytes) > 0)
		//	quickQuery("UPDATE summary SET upbytes=upbytes + $upbytes WHERE info_hash=\"$hash\"");
	}
}

// Updates the peer user's info.
// Currently it only updates the "lastupdate" value
function updatePeer($peerid, $hash)
{
	$now = $GLOBALS["time"];
	quickQuery("UPDATE x$hash set lastupdate=$now where peer_id=\"$peerid\"");
}


// Transfers bytes from "left" to "dlbytes" when a peer reports in.
function collectBytes($peer, $hash, $left, $upload)
{
	$diff = sqlSubtract($peer["bytes"], $left);
	$peerid=$peer["peer_id"];

	// Anti-negative clause
	if (((float)$diff) > 0)
		quickQuery("UPDATE summary SET dlbytes=dlbytes+$diff WHERE info_hash=\"$hash\"");

	quickQuery("UPDATE x$hash set bytes=\"$left\", upbytes=\"$upload\" where peer_id=\"$peerid\"");

	//$diffup = sqlSubtract($upload, $peer["upbytes"]);
	//if (((float)$diffup) > 0)
	//	quickQuery("UPDATE summary SET upbytes=upbytes+$diffup WHERE info_hash=\"$hash\"");
}

// Transmits the actual data to the peer. No other output is permitted if
// this function is called, as that would break BEncoding.
// I don't use the bencode library, so watch out! If you add data,
// rules such as dictionary sorting are enforced by the remote side, so watch out.
function sendPeerList($peers)
{
	echo "d";
  	if (isset($peers["num seeds"]))
  	        echo "10:done peersi".$peers["num seeds"]."e";


  	echo "8:intervali".$GLOBALS["report_interval"]."e";


        if (isset($peers["last"]) && $GLOBALS["maxpeers"] == $peers["size"])
 		echo "4:lasti".$peers["last"]."e";


	if (isset($GLOBALS["min_interval"]))
		echo "12:min intervali".$GLOBALS["min_interval"]."e";
	if (isset($peers["num peers"]))
		echo "9:num peersi".$peers["num peers"]."e";

	echo "5:peersl";
	$size=$peers["size"];
	for ($i=0; $i < $size; $i++)
	{
		// bencoding can kiss my butt for now. See BEncode.php
		$peerid = hex2bin($peers[$i]["peer_id"]);
		echo "d2:ip".strlen($peers[$i]["ip"]).":".$peers[$i]["ip"]."7:peer id".strlen($peerid).":".$peerid."4:porti".$peers[$i]["port"]."ee";
	}
	echo "e";
	
	if (isset($GLOBALS["trackerid"]))
	{
		// Now it gets annoying. trackerid is a string
		$trackerid = (string)$GLOBALS["trackerid"];
		echo "10:tracker id".strlen($trackerid).":$trackerid";

	}

	echo "e";
}

// Returns a $peers array of all peers that have timed out (2* report interval seems fair
// for any reasonable report interval (900 or larger))
function loadLostPeers($hash, $now, $timeout)
{
	$results = mysql_query("SELECT peer_id,bytes,ip,port,status,lastupdate,upbytes from x$hash where lastupdate < ($now - 2 * $timeout)");
	$peerno = 0;
	if (!$results)
		return false;
	while ($data = mysql_fetch_row($results))
	{
		$return[$peerno]["peer_id"] = $data[0];
		$return[$peerno]["bytes"] = $data[1];
		$return[$peerno]["ip"] = $data[2];
		$return[$peerno]["port"]=$data[3];
		$return[$peerno]["status"] = $data[4];
		$return[$peerno]["lastupdate"] = $data[5];
		$return[$peerno]["upbytes"] = $data[6];
		$peerno++;	
	}
	$return["size"] = $peerno;
	mysql_free_result($results);
	return $return;
}

function trashCollector($hash, $timeout, $now)
{
	if (!Lock($hash))
		return;
	
	$results = mysql_query("SELECT lastcycle FROM summary WHERE info_hash='$hash'");
	$lastcheck = (mysql_fetch_row($results));
	
	// Check once every re-announce cycle
	if (($lastcheck[0] + $timeout) < $now)
	{
		$peers = loadLostPeers($hash, $now, $timeout);
		for ($i=0; $i < $peers["size"]; $i++)
			killPeer($peers[$i]["peer_id"], $hash, $peers[$i]["bytes"], $peers[$i]["upbytes"]);
		quickQuery("UPDATE summary SET lastcycle='$now' WHERE info_hash='$hash'");
	}
	Unlock($hash);
}

// Attempts to aquire a lock by name.
// Returns true on success, false on failure
function Lock($hash, $time = 0)
{
	$results = mysql_query("SELECT GET_LOCK('$hash', $time)");
	$string = mysql_fetch_row($results);
	if (strcmp($string[0], "1") == 0)
		return true;
	return false;

}

// Releases a lock. Ignores errors.
function Unlock($hash)
{
	quickQuery("SELECT RELEASE_LOCK('$hash')");
}

// Returns true if the lock is available
function isFreeLock($lock)
{
	if (Lock($lock, 0))
	{
		Unlock($lock);
		return true;
	}
	return false;
}


/* Returns true if the user is firewalled, NAT'd, or whatever.
 * The original tracker had its --nat_check parameter, so
 * here is my version.
 *
 * This code has proven itself to be sufficiently correct,
 * but will consume system resources when a lot of httpd processes
 * are lingering around trying to connect to remote hosts.
 * Consider disabling it under higher loads.
 */
function isFireWalled($hash, $peerid, $ip, $port)
{

	// NAT checking off?
	if (!$GLOBALS["NAT"])
		return false;


	

	$protocol_name = 'BitTorrent protocol';
	$theError = "";
	// Hoping 10 seconds will be enough
	$fd = fsockopen($ip, $port, $errno, $theError, 10);
	if (!$fd)
		return true;

	stream_set_timeout($fd, 5, 0);
	fwrite($fd, chr(strlen($protocol_name)).$protocol_name.hex2bin("0000000000000000").
		hex2bin($hash));
	
	$data = fread($fd, strlen($protocol_name)+1+20+20+8); // ideally...

	fclose($fd);
	$offset = 0;

	// First byte: strlen($protocol_name), then the protocol string itself
	if (ord($data[$offset]) != strlen($protocol_name))
		return true;

	$offset++;
	if (substr($data, $offset, strlen($protocol_name)) != $protocol_name)
		return true;

	$offset += strlen($protocol_name);
	// 8 bytes reserved, ignore
	$offset += 8;
	
	// Download ID (hash)
	if (substr($data, $offset, 20) != hex2bin($hash))
		return true;

	$offset+=20;
	
	// Peer ID
	if (substr($data, $offset, 20) != hex2bin($peerid))
		return true;

	
	return false;
}


// It's cruel, but if people abuse my tracker, I just might do it.
// It pretends to accept the torrent, and reports that you are the
// only person connected.
function evilReject($ip, $peer_id, $port)
{

	// For those of you who are feeling evil, comment out this line.
	showError("Torrent is not authorized for use on this tracker.");

	$peers[0]["peer_id"] = $peer_id;
	$peers[0]["ip"] = $ip;
	$peers[0]["port"] = $port;
	$peers["size"] = 1;
	$GLOBALS["report_interval"] = 86400;
	$GLOBALS["min_interval"] = 86000;
	sendPeerList($peers);
	exit(0);
}


function runSpeed($info_hash, $delta)
{
	// Start by grabbing the data we need.
	$results = mysql_query("SELECT dlbytes FROM summary WHERE info_hash=\"$info_hash\"");
	$dlbytes = mysql_fetch_row($results);
	$dlbytes = $dlbytes[0];
	quickQuery("INSERT INTO timestamps SET info_hash=\"$info_hash\", bytes=$dlbytes, delta=$delta");

	// Read in the speed columns
	$results = mysql_query("SELECT bytes, delta, sequence FROM timestamps WHERE info_hash=\"$info_hash\" ORDER BY sequence");
	$rowcount = mysql_num_rows($results);
	$summ = 0;
	for ($i=0; $i < $rowcount; $i++)
	{
		$row[$i] = mysql_fetch_row($results);
		$summ += $row[$i][1];
	}
	$bytedifference = sqlSubtract($row[$rowcount-1][0], $row[0][0]);

	// Make database changes
	if ($summ == 0)
		quickQuery("UPDATE summary SET speed=-1 WHERE info_hash=\"$info_hash\"");
	else
		quickQuery("UPDATE summary SET speed=$bytedifference / $summ WHERE info_hash=\"$info_hash\"");
	if ($rowcount > 20)
		quickQuery("DELETE FROM timestamps WHERE sequence=".$row[0][2]);

}


// Even if you're missing PHP 4.3.0, the MHASH extension might be of use.
// Someone was kind enought to email this code snippit in.
if (function_exists('mhash') && (!function_exists('sha1')) && 
defined('MHASH_SHA1'))
{
  function sha1($str)
                {
      return bin2hex(mhash(MHASH_SHA1,$str));
                }
}


?>